<template>
    <div class="flex items-center justify-between mb-4">
        <Breadcrumb nameRouteHome="teacher" textRouteHome="Trang chủ">
            <ItemBreadcrumb>Khóa học của tôi</ItemBreadcrumb>
        </Breadcrumb>
        <LinkButton nameRoute="teacher-course-create">
            <PlusCircleIcon class="text-white" />
            <span>Tạo khóa học</span>
        </LinkButton>
    </div>

    <div class="card">
        <div class="card-header border-b-none">
            <form
                @submit.prevent="submitSearchForm"
                class="flex items-end gap-3"
            >
                <div class="form-control">
                    <div>Tên khóa học:</div>
                    <label for="name">
                        <input
                            v-model="name"
                            id="name"
                            type="text"
                            class="focus:border-main-color rounded-md border border-gray-200 text-sm mt-1 px-3 py-2"
                            placeholder="Tên khóa học..."
                            autocomplete="off"
                        />
                    </label>
                </div>
                <div class="form-control">
                    <label for="category">
                        <div>Môn học:</div>
                        <select
                            v-model="category"
                            id="category"
                            class="focus:border-main-color rounded-md border border-gray-200 mt-1 px-3 py-2"
                        >
                            <option value="">Tất cả</option>
                            <option
                                :key="category.id"
                                v-for="category in SELECT_OPTION_COURSE_CATEGORY"
                                :value="category.id"
                            >
                                {{ category.text }}
                            </option>
                        </select>
                    </label>
                </div>
                <BasicButton
                    type="submit"
                    classCustom="bg-color-warning hover:shadow-hover-warning"
                >
                    <SearchIcon class="text-white" />
                    <span>Tìm kiếm</span>
                </BasicButton>
            </form>
        </div>
        <table>
            <thead>
                <tr>
                    <th>Thông tin khóa học</th>
                    <th class="text-center">Môn học</th>
                    <th class="text-center">Tổng số bài học</th>
                    <th class="text-center">Trạng thái</th>
                    <th>Thời gian tạo</th>
                    <th class="text-center">Hành động</th>
                </tr>
            </thead>
            <tbody>
                <template v-if="!isLoading">
                    <template v-if="coursesComputed && coursesComputed.length">
                        <tr :key="course.id" v-for="course in coursesComputed">
                            <td class="w-400">
                                <div class="flex gap-3">
                                    <img
                                        :src="
                                            course.image
                                                ? course.image
                                                : require('@/assets/images/no-image.webp')
                                        "
                                        class="w-28 min-w-28 h-full"
                                        alt=""
                                    />
                                    <div>
                                        <div class="text-lg font-semibold">
                                            {{ course.name }}
                                        </div>
                                        <p
                                            class="line-clamp-3"
                                            v-html="course.description"
                                        ></p>
                                    </div>
                                </div>
                            </td>
                            <td class="text-center">
                                {{ course.course_category }}
                            </td>
                            <td class="text-center">
                                {{ course.total_lesson }}
                            </td>
                            <td class="text-center">
                                <span
                                    v-if="course.status === STATUS_COURSE_DRAFT"
                                    class="bg-color-danger text-white text-xs font-semibold rounded-2xl px-3 py-1"
                                >
                                    Nháp
                                </span>
                                <span
                                    v-else-if="
                                        course.status === STATUS_COURSE_COMPLETE
                                    "
                                    class="bg-color-primary text-white text-xs font-semibold rounded-2xl px-3 py-1"
                                >
                                    Hoàn thành
                                </span>
                                <span
                                    v-else-if="
                                        course.status === STATUS_COURSE_PUBLIC
                                    "
                                    class="bg-color-success text-white text-xs font-semibold rounded-2xl px-3 py-1"
                                >
                                    Đã duyệt
                                </span>
                            </td>
                            <td>{{ course.created_at }}</td>
                            <td>
                                <div
                                    class="box-actions flex items-center justify-center gap-1"
                                >
                                    <router-link
                                        :to="{
                                            name: 'teacher-course-view',
                                            params: { courseId: course.id },
                                            hash: '#overview'
                                        }"
                                        v-tooltip="'Xem'"
                                        class="action-view"
                                    >
                                        <EyeIcon />
                                    </router-link>
                                    <router-link
                                        :to="{
                                            name: 'teacher-course-update',
                                            params: { courseId: course.id }
                                        }"
                                        v-tooltip="'Sửa'"
                                        class="action-edit"
                                    >
                                        <PencilIcon />
                                    </router-link>
                                    <div
                                        @click="onDelete(course.id)"
                                        v-tooltip="'Xóa'"
                                        class="cursor-pointer action-delete"
                                    >
                                        <TrashIcon />
                                    </div>
                                </div>
                            </td>
                        </tr>
                    </template>
                    <template v-else>
                        <tr class="no-data-table">
                            <td colspan="6" class="text-center">
                                Không có dữ liệu
                            </td>
                        </tr>
                    </template>
                </template>
                <template v-else>
                    <tr>
                        <td colspan="6" class="text-center">
                            <SpinLoading />
                        </td>
                    </tr>
                </template>
            </tbody>
        </table>
        <div
            v-if="!isLoading && coursesComputed && coursesComputed.length"
            class="flex justify-end p-6"
        >
            <BasicPagination
                @onClickPage="onClickPage"
                :currentPage="currentPage"
                :lastPage="lastPage"
            />
        </div>
    </div>
</template>

<script>
import { computed, ref, watch } from "vue";
import { useRoute, useRouter } from "vue-router";
import {
    ROLE_ADMIN,
    ROLE_TEACHER,
    SELECT_OPTION_ROLE,
    SELECT_OPTION_COURSE_CATEGORY,
    STATUS_COURSE_DRAFT,
    STATUS_COURSE_COMPLETE,
    STATUS_COURSE_PUBLIC
} from "@/constants";
import timeHelper from "@/helper/timeHelper";
import Swal from "sweetalert2";
import { createToast } from "mosha-vue-toastify";

import useFetchMyCourse from "@/hooks/course/useFetchMyCourse";
import useDeleteCourse from "@/hooks/course/useDeleteCourse";

import {
    PlusCircleIcon,
    SearchIcon,
    EyeIcon,
    PencilIcon,
    TrashIcon
} from "@heroicons/vue/outline";
import SpinLoading from "@/components/loading/SpinLoading.vue";
import Breadcrumb from "@/components/breadcrumb/Breadcrumb.vue";
import ItemBreadcrumb from "@/components/breadcrumb/ItemBreadcrumb.vue";
import BasicButton from "@/components/button/BasicButton.vue";
import LinkButton from "@/components/button/LinkButton.vue";
import BasicPagination from "@/components/pagination/BasicPagination.vue";

export default {
    components: {
        PlusCircleIcon,
        SearchIcon,
        EyeIcon,
        PencilIcon,
        TrashIcon,
        SpinLoading,
        Breadcrumb,
        ItemBreadcrumb,
        BasicButton,
        LinkButton,
        BasicPagination
    },
    setup() {
        const route = useRoute();
        const router = useRouter();
        const courses = ref([]);
        const { isLoading, listCourse, onFetchMyCourse } = useFetchMyCourse();
        const { errorResponse, onDeleteCourse } = useDeleteCourse();

        async function onFetch() {
            await onFetchMyCourse(route.query);
            courses.value = listCourse.value.data;
        }
        onFetch();

        const coursesComputed = computed(() => {
            if (courses.value && courses.value.length) {
                return courses.value.map(course => {
                    let course_category;
                    SELECT_OPTION_COURSE_CATEGORY.forEach(category => {
                        if (course.course_category_id === category.id)
                            course_category = category.text;
                    });
                    return {
                        ...course,
                        course_category,
                        created_at: timeHelper.getTimeString(
                            "H:i:s - d/m/Y",
                            timeHelper.getTimeInt(course.created_at)
                        )
                    };
                });
            } else {
                return [];
            }
        });

        // search
        const name = ref(route.query.name || null);
        const category = ref(route.query.category || "");
        async function submitSearchForm() {
            await onFetchMyCourse({
                name: name.value,
                category: category.value
            });
            courses.value = listCourse.value.data;

            const path = route.path;

            let query = {};
            if (name.value) query = { ...query, name: name.value };
            if (category.value !== null && category.value !== "")
                query = { ...query, category: category.value };

            router.push({ path, query });
        }

        // update currentPge and lastPage when change listCourse
        const currentPage = ref(1);
        const lastPage = ref(1);
        watch(listCourse, newValue => {
            currentPage.value = newValue.current_page;
            lastPage.value = newValue.last_page;
        });

        // click pagination
        async function onClickPage(value) {
            router.push({
                path: route.path,
                query: { ...route.query, page: value }
            });

            await onFetchMyCourse({ ...route.query, page: value });
            courses.value = listCourse.value.data;
        }

        // deleteUser
        async function onDelete(id) {
            Swal.fire({
                icon: "question",
                title: `<span style="font-size: 23px;">Bạn có chắc muốn xóa khóa học này không?</span>`,
                confirmButtonText: "Xóa",
                showDenyButton: true,
                denyButtonText: "Hủy",
                focusConfirm: false
            }).then(async result => {
                if (result.isConfirmed) {
                    // show loading
                    document.getElementById("full-page-loading").style.display =
                        "block";

                    await onDeleteCourse(id);

                    // hide loading
                    document.getElementById("full-page-loading").style.display =
                        "none";

                    // check error from server
                    if (errorResponse.value) {
                        createToast("Xóa thất bại, đã có lỗi xảy ra", {
                            showIcon: true,
                            type: "danger"
                        });
                    } else {
                        courses.value = courses.value.filter(course => {
                            return course.id != id;
                        });
                        createToast("Xóa thành công", {
                            showIcon: true,
                            type: "success"
                        });
                    }
                }
            });
        }

        return {
            ROLE_ADMIN,
            ROLE_TEACHER,
            SELECT_OPTION_ROLE,
            SELECT_OPTION_COURSE_CATEGORY,
            STATUS_COURSE_DRAFT,
            STATUS_COURSE_COMPLETE,
            STATUS_COURSE_PUBLIC,
            isLoading,
            coursesComputed,
            name,
            category,
            submitSearchForm,
            currentPage,
            lastPage,
            onClickPage,
            onDelete
        };
    }
};
</script>
